org.springframework.web.socket.sockjs.client

## Interface XhrTransport

All Superinterfaces:
  InfoReceiver, Transport

All Known Implementing Classes:
  AbstractXhrTransport, JettyXhrTransport, RestTemplateXhrTransport, UndertowXhrTransport

    public interface XhrTransport
    extends Transport, InfoReceiver

A SockJS `Transport` that uses HTTP requests to simulate a WebSocket interaction. The `connect` method of the base `Transport` interface is used to receive messages from the server while the `executeSendRequest(java.net.URI, org.springframework.http.HttpHeaders, org.springframework.web.socket.TextMessage)` method here is used to send messages.

Since:
  4.1
Author:
  Rossen Stoyanchev

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `executeSendRequest(URI transportUrl, org.springframework.http.HttpHeaders headers, TextMessage message)` Execute a request to send the message to the server.
`boolean` `isXhrStreamingDisabled()` An `XhrTransport` supports both the "xhr_streaming" and "xhr" SockJS server transports.

### Methods inherited from interface org.springframework.web.socket.sockjs.client.Transport

`connect, getTransportTypes`

### Methods inherited from interface org.springframework.web.socket.sockjs.client.InfoReceiver

`executeInfoRequest`

### Method Detail

#### isXhrStreamingDisabled

    boolean isXhrStreamingDisabled()

An `XhrTransport` supports both the "xhr_streaming" and "xhr" SockJS server transports. From a client perspective there is no implementation difference.

By default an `XhrTransport` will be used with "xhr_streaming" first and then with "xhr", if the streaming fails to connect. In some cases it may be useful to suppress streaming so that only "xhr" is used.

#### executeSendRequest

    void executeSendRequest(URI transportUrl,
                            org.springframework.http.HttpHeaders headers,
                            TextMessage message)

Execute a request to send the message to the server.

Note that as of 4.2 this method accepts a `headers` parameter.

Parameters:
  `transportUrl` - the URL for sending messages.
  `message` - the message to send